diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index 52be746e3..920ca6120 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -5,7 +5,7 @@ import com.mojang.nbt.tags.ListTag;
 import net.minecraft.core.block.BlockLogicBed;
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.entity.TileEntitySign;
-import net.minecraft.core.entity.EntityItem;
+import net.minecraft.core.entity.*;
 import net.minecraft.core.entity.animal.MobPig;
 import net.minecraft.core.entity.animal.MobWolf;
 import net.minecraft.core.entity.monster.MobCreeper;
@@ -13,7 +13,7 @@ import net.minecraft.core.entity.monster.MobSlime;
 import net.minecraft.core.entity.monster.MobSpider;
 import net.minecraft.core.entity.monster.MobZombiePig;
 import net.minecraft.core.entity.projectile.ProjectileArrow;
-import net.minecraft.core.enums.Difficulty;
+import net.minecraft.core.enums.*;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.achievement.stat.Stat;
 import net.minecraft.core.achievement.stat.StatList;
@@ -26,12 +26,6 @@ import net.minecraft.core.block.entity.TileEntityFurnace;
 import net.minecraft.core.block.entity.TileEntityTrommel;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.data.gamerule.GameRules;
-import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityDispatcher;
-import net.minecraft.core.entity.EntityFishingBobber;
-import net.minecraft.core.entity.EntityLightning;
-import net.minecraft.core.entity.Mob;
-import net.minecraft.core.entity.EntityPrimedTNT;
 import net.minecraft.core.entity.monster.MobGhast;
 import net.minecraft.core.entity.monster.MobGiant;
 import net.minecraft.core.entity.monster.MobMonster;
@@ -43,10 +37,6 @@ import net.minecraft.core.entity.projectile.ProjectileFireball;
 import net.minecraft.core.entity.projectile.ProjectileArrowGolden;
 import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.entity.vehicle.MinecartEntity;
-import net.minecraft.core.enums.ArtType;
-import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.enums.EnumSleepStatus;
-import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
@@ -77,7 +67,7 @@ import java.util.Comparator;
 import java.util.List;
 import java.util.UUID;
 
-public abstract class Player extends Mob
+public abstract class Player extends Mob implements IArmorWearing<HumanArmorShape>
 {
     public static final int DATA_UNKNOWN = 16; // I have no idea wtf this id is for
     public static final int DATA_SELECTED_ART = 17;
@@ -196,7 +186,12 @@ public abstract class Player extends Mob
     @Override
     public boolean canSkate() 
     {
-        return inventory.armorInventory[IArmorItem.PIECE_BOOTS] != null && inventory.armorInventory[IArmorItem.PIECE_BOOTS].itemID == Items.ARMOR_BOOTS_ICESKATES.id;
+        final @Nullable ItemStack armor = getItemInArmorSlot(HumanArmorShape.BOOTS);
+        if (armor == null) {
+            return false;
+        } else {
+            return armor.itemID == Items.ARMOR_BOOTS_ICESKATES.id;
+        }
     }
 
     @Override
@@ -946,7 +941,10 @@ public abstract class Player extends Mob
 
     @Override
 	protected void damageEntity(int damage, DamageType damageType) {
-    	float protection = 1.0f - inventory.getTotalProtectionAmount(damageType);
+    	float protection = 1.0f;
+        if (damageType != null) {
+            protection -= getTotalProtectionAmount(damageType);
+        }
     	protection = Math.max(protection, 0.01f);
     	
     	//If you take little damage and have lots of protection against that damage
@@ -958,7 +956,7 @@ public abstract class Player extends Mob
     	if(damageType != null && damageType.shouldDamageArmor()){
         	//Reduce armor for big damage amounts, for example explosions
         	int armorDamage = (int) Math.ceil(preventedDamage / 4.0);
-        	inventory.damageArmor(armorDamage);
+        	damageArmor(armorDamage);
     	}
     	
         super.damageEntity(newDamage, damageType);
@@ -968,7 +966,7 @@ public abstract class Player extends Mob
     {
         if(!fireImmune)
         {
-            float protection = 1.0f - inventory.getTotalProtectionAmount(DamageType.FIRE);
+            float protection = 1.0f - getTotalProtectionAmount(DamageType.FIRE);
             protection = Math.max(protection, 0.01f);
             hurt(null, 4, DamageType.FIRE);
             remainingFireTicks = (int) (80 + 520 * protection);
@@ -980,7 +978,7 @@ public abstract class Player extends Mob
     {
         if(!fireImmune)
         {
-            float protection = 1.0f - inventory.getTotalProtectionAmount(DamageType.FIRE);
+            float protection = 1.0f - getTotalProtectionAmount(DamageType.FIRE);
             protection = Math.max(protection, 0.01f);
             hurt(null, 1, DamageType.FIRE);
             remainingFireTicks = (int) (40 + 260 * protection);
@@ -1635,7 +1633,7 @@ public abstract class Player extends Mob
     }
     public Item getNextArrow(){
         Item nextArrow = null;
-        ItemStack quiverSlot = inventory.armorItemInSlot(IArmorItem.PIECE_CHEST);
+        ItemStack quiverSlot = getItemInArmorSlot(HumanArmorShape.CHEST);
         if(quiverSlot != null && quiverSlot.itemID == Items.ARMOR_QUIVER.id && quiverSlot.getMetadata() < quiverSlot.getMaxDamage()){
             nextArrow = Items.AMMO_ARROW;
         }
@@ -1661,6 +1659,33 @@ public abstract class Player extends Mob
         }
         return false;
     }
+
+    @Override
+    public @Nullable ItemStack getItemInArmorSlot(final @NotNull HumanArmorShape slot) {
+        return this.inventory.armorInventory[slot.getSlotIndex()];
+    }
+
+    @Override
+    public void setItemInArmorSlot(final @NotNull HumanArmorShape slot, final @Nullable ItemStack item) {
+        if (slot == HumanArmorShape.HEAD || canItemGoInArmorSlot(slot, item)) {
+            this.inventory.armorInventory[slot.getSlotIndex()] = item;
+        }
+    }
+
+    @Override
+    public int getNumArmorSlots() {
+        return HumanArmorShape.values().length;
+    }
+
+    @Override
+    public @Nullable HumanArmorShape getArmorSlotByIndex(int index) {
+        if (index < 0 || index >= HumanArmorShape.values().length) {
+            return null;
+        }
+
+        return HumanArmorShape.values()[index];
+    }
+
     public static class SortByUsername implements Comparator<Player> {
 
         @Override
diff --git a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
index 28511eb1b..14eac3f09 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
@@ -444,6 +444,11 @@ public class EntityBoat extends Entity
         }
     }
 
+    @Override
+    public void waterHurt() {
+        return;
+    }
+
     @Override
     public void addAdditionalSaveData(@NotNull CompoundTag tag)
     {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/vehicle/MobGhastVehicle.java b/game/core/src/main/java/net/minecraft/core/entity/vehicle/MobGhastVehicle.java
new file mode 100644
index 000000000..8f88ac0fe
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/entity/vehicle/MobGhastVehicle.java
@@ -0,0 +1,444 @@
+package net.minecraft.core.entity.vehicle;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.TileEntityFlag;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.monster.MobGhast;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.player.gamemode.Gamemode;
+import net.minecraft.core.util.collection.NamespaceID;
+import net.minecraft.core.util.helper.BlockParticleHelper;
+import net.minecraft.core.util.helper.DamageType;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.World;
+
+import java.util.List;
+
+public class MobGhastVehicle extends MobGhast
+{
+    private static final double MAX_BOAT_SPEED = 1.2D;
+    private static final double ACCELERATION = 0.03D;
+    private static final float MAX_ROTATION_SPEED = 5f;
+    private static final float MIN_ROTATION_SPEED = 3f;
+    private static final double MAX_PACKET_SPEED_CHANGE = ACCELERATION * 8;
+    private static final double MAX_PACKET_ROTATION_CHANGE = MAX_ROTATION_SPEED * 4;
+    public int boatCurrentDamage;
+    public int boatTimeSinceHit;
+    public int boatRockDirection;
+    private int lerpTicks;
+    private double lerpX;
+    private double lerpY;
+    private double lerpZ;
+    private float lerpYRot;
+    private float boatPitch;
+    private double velocityX;
+    private double velocityY;
+    private double velocityZ;
+    private float pendingYRot;
+    private double pendingXDChange;
+    private double pendingYDChange;
+    private double pendingZDChange;
+
+
+    public MobGhastVehicle(World world)
+    {
+        super(world);
+        boatCurrentDamage = 0;
+        boatTimeSinceHit = 0;
+        boatRockDirection = 1;
+        blocksBuilding = true;
+        sendAdditionalData = true;
+        textureIdentifier = new NamespaceID("minecraft", "ghast_vehicle");
+    }
+
+    @Override
+    public void lookAt(Entity entity, float yRot, float xRot) {
+        return;
+    }
+
+    @Override
+    protected void updateAI() {
+        return;
+    }
+
+    @Override
+    public void onLivingUpdate() {
+        return;
+    }
+
+    @Override
+	protected boolean makeStepSound()
+    {
+        return false;
+    }
+
+    @Override
+	public AABB getBb()
+    {
+        return bb;
+    }
+
+    @Override
+	public boolean isPushable()
+    {
+        return true;
+    }
+
+    public MobGhastVehicle(World world, double d, double d1, double d2)
+    {
+        this(world);
+        setPos(d, d1 + (double) heightOffset, d2);
+        xd = 0.0D;
+        yd = 0.0D;
+        zd = 0.0D;
+        xo = d;
+        yo = d1;
+        zo = d2;
+    }
+
+    @Override
+	public double getRideHeight()
+    {
+        return (double) bbHeight - 0.3D;
+    }
+    @Override
+    public boolean hurt(Entity entity, int i, DamageType type)
+    {
+        int numParticles = random.nextInt(8) + 1;
+        for (int q = 0; q < numParticles; q++)
+        {
+            world.spawnParticle("block", x, y, z, xd, yd, zd, BlockParticleHelper.encodeBlockData(Blocks.PLANKS_OAK.id(), 0, Side.BOTTOM));
+        }
+        if(world.isClientSide || removed)
+        {
+            return true;
+        }
+        boatRockDirection = -boatRockDirection;
+        boatTimeSinceHit = 10;
+        boatCurrentDamage += i * 10;
+        markHurt();
+        if(boatCurrentDamage > 40)
+        {
+            if(passenger != null)
+            {
+                passenger.startRiding(this);
+            }
+            if(entity instanceof Player){
+                dropItem(Items.BOAT.id, 1, 0.0F);
+            }else {
+                for (int j = 0; j < 3; j++) {
+                    dropItem(Blocks.PLANKS_OAK.id(), 1, 0.0F);
+                }
+
+                for (int k = 0; k < 2; k++) {
+                    dropItem(Items.STICK.id, 1, 0.0F);
+                }
+            }
+
+            remove();
+        }
+        return true;
+    }
+
+    @Override
+    public void remove(){
+        Entity entity = passenger;
+
+        if (entity != null){
+            double bbCenterX = (bb.minX + bb.maxX)/2;
+            double bbCenterZ = (bb.minZ + bb.maxZ)/2;
+
+            this.passenger = null;
+            entity.vehicle = null;
+            entity.moveTo(bbCenterX, this.bb.maxY + 0.1, bbCenterZ, entity.yRot, entity.xRot);
+        }
+
+        super.remove();
+    }
+
+    @Override
+	public void animateHurt()
+    {
+        boatRockDirection = -boatRockDirection;
+        boatTimeSinceHit = 10;
+        boatCurrentDamage += boatCurrentDamage * 10;
+    }
+
+    @Override
+	public boolean isPickable()
+    {
+        return !removed;
+    }
+
+    @Override
+	public void lerpTo(double x, double y, double z, float yRot,
+                       float xRot, int i)
+    {
+        lerpX = x;
+        lerpY = y;
+        lerpZ = z;
+        boatPitch = xRot;
+        lerpTicks = i;
+        // Don't interpolate velocity from server when controlling the boat
+        if (passenger != null && !passenger.lerpVehicleMotion()) return;
+        lerpYRot = yRot;
+        xd = velocityX;
+        yd = velocityY;
+        zd = velocityZ;
+    }
+
+    @Override
+	public void lerpMotion(double xd, double yd, double zd)
+    {
+        // Don't interpolate velocity from server when controlling the boat
+        if (passenger != null && !passenger.lerpVehicleMotion()) return;
+        velocityX = this.xd = xd;
+        velocityY = this.yd = yd;
+        velocityZ = this.zd = zd;
+    }
+    @Override
+	public void tick()
+    {
+        setRot(yRot, xRot);
+        super.tick();
+        if(boatTimeSinceHit > 0)
+        {
+            boatTimeSinceHit--;
+        }
+        if(boatCurrentDamage > 0)
+        {
+            boatCurrentDamage--;
+        }
+        xo = x;
+        yo = y;
+        zo = z;
+        if(world.isClientSide)
+        {
+            if(lerpTicks > 0)
+            {
+                double lerpX = x + (this.lerpX - x) / (double) lerpTicks;
+                double lerpY = y + (this.lerpY - y) / (double) lerpTicks;
+                double lerpZ = z + (this.lerpZ - z) / (double) lerpTicks;
+                xRot += (boatPitch - xRot) / lerpTicks;
+                if (passenger == null || passenger.lerpVehicleMotion()){
+                    float lerpYRot;
+                    lerpYRot = MathHelper.normalizeRotation(this.lerpYRot - yRot);
+                    yRot += lerpYRot / lerpTicks;
+                }
+                lerpTicks--;
+                setPos(lerpX, lerpY, lerpZ);
+            }
+            boatMovement();
+            move(xd , yd, zd);
+            setRot(yRot, xRot);
+            xd *= 0.99D;
+            yd *= 0.99D;
+            zd *= 0.99D;
+            return;
+        }
+
+        boatMovement();
+
+        if (passenger == null){
+            float nextYRot = yRot;
+            if(Math.hypot(xd, zd) > 0.001D)
+            {
+                nextYRot = (float)Math.toDegrees(Math.atan2(zd, xd)) + 180;
+            }
+            float changeInYRot;
+            changeInYRot = MathHelper.normalizeRotation(nextYRot - yRot);
+            changeInYRot = MathHelper.clamp(changeInYRot, -20F, 20F);
+            yRot = MathHelper.normalizeRotation(yRot + changeInYRot);
+            setRot(yRot, xRot);
+        }
+
+        move(xd, yd, zd);
+
+        if (passenger == null || !passenger.deferVehicleBehavior()){
+            xd *= 0.99D;
+            yd *= 0.99D;
+            zd *= 0.99D;
+        }
+
+        xRot = 0.0F;
+
+        // Push entities in bounding box
+        List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(this, bb.grow(0.2D, 0.0D, 0.2D));
+        if(list != null && !list.isEmpty())
+        {
+            for (Entity entity : list) {
+                if (entity != passenger && entity.isPushable() && (entity instanceof MobGhastVehicle)) {
+                    entity.push(this);
+                }
+            }
+        }
+
+        // Remove passenger is passenger removal is queued
+        if(passenger != null && passenger.removed)
+        {
+            passenger = null;
+        }
+
+        yBodyRot = yRot + 90;
+    }
+    public void boatMovement(){
+        double boatRad = Math.toRadians(yRot + 90);
+        double vectorRad = Math.atan2(xd, zd);
+        double currentBoatSpeed;
+        if (passenger != null){
+            boolean isBackwards = Math.cos(-boatRad - vectorRad) < 0;
+            double ang = vectorRad + boatRad + (isBackwards ? Math.PI : 0);
+
+            double _xd = xd;
+            xd = _xd * Math.cos(ang) - zd * Math.sin(ang);
+            zd = _xd * Math.sin(ang) + zd * Math.cos(ang);
+        }
+
+        double xdOff;
+        double ydOff;
+        double zdOff;
+        currentBoatSpeed = Math.hypot(xd, zd);
+        if(passenger != null) {
+            passenger.handleSpecialVehicleControl();
+        }
+        yRot += pendingYRot;
+        pendingYRot = 0;
+        xdOff = pendingXDChange;
+        ydOff = pendingYDChange;
+        zdOff = pendingZDChange;
+        pendingXDChange = 0;
+        pendingYDChange = 0;
+        pendingZDChange = 0;
+
+        double offsetMagnitude = Math.hypot(xdOff, zdOff);
+        double vecAngle = Math.acos((xd * xdOff + zd * zdOff)/ ((currentBoatSpeed + 0.00000000001D) * (offsetMagnitude + 0.00000000001D)));
+        double multiplier = (1 + (vecAngle/Math.PI)); // Increase acceleration if it runs opposite to the current motion vector
+        xdOff *= multiplier;
+        ydOff *= multiplier;
+        zdOff *= multiplier;
+
+//        System.out.printf("%f %f\n", xdOff, zdOff);
+
+        xd += xdOff;
+        yd += ydOff;
+        zd += zdOff;
+
+        if(passenger != null) {
+            passenger.sendSpecialVehiclePacket();
+        }
+
+        // Cap max speed properly
+        currentBoatSpeed = Math.hypot(xd, zd);
+        if (currentBoatSpeed > MAX_BOAT_SPEED){
+            xd = xd/currentBoatSpeed * MAX_BOAT_SPEED;
+            yd = yd/currentBoatSpeed * MAX_BOAT_SPEED;
+            zd = zd/currentBoatSpeed * MAX_BOAT_SPEED;
+        }
+
+        if(onGround)
+        {
+            xd *= 0.5D;
+            yd *= 0.5D;
+            zd *= 0.5D;
+        }
+    }
+
+    public void controlVehicle(float forward, float strafe, boolean jump, boolean sneak){
+        double currentBoatSpeed = Math.hypot(xd, zd);
+        pendingYRot = (float) (strafe * (MIN_ROTATION_SPEED + (MAX_ROTATION_SPEED - MIN_ROTATION_SPEED) * Math.max(((MAX_BOAT_SPEED - (currentBoatSpeed * 1.5))/ MAX_BOAT_SPEED), 0))); // I love interpolation
+        float velOff = (float) (forward * ACCELERATION);
+        pendingXDChange = Math.cos(Math.toRadians(yRot)) * velOff;
+        pendingZDChange = Math.sin(Math.toRadians(yRot)) * velOff;
+
+        if (jump && !sneak) {
+            pendingYDChange = ACCELERATION;
+        }
+        if (sneak && !jump) {
+            pendingYDChange = -ACCELERATION;
+        }
+    }
+
+    public void handleControlDirect(float xd, float zd, float yRot){
+        this.yRot = (float) MathHelper.clamp(yRot, this.yRot - MAX_PACKET_ROTATION_CHANGE, this.yRot + MAX_PACKET_ROTATION_CHANGE);
+        this.xd = MathHelper.clamp(xd, this.xd - MAX_PACKET_SPEED_CHANGE, this.xd + MAX_PACKET_SPEED_CHANGE);
+        this.zd = MathHelper.clamp(zd, this.zd - MAX_PACKET_SPEED_CHANGE, this.zd + MAX_PACKET_SPEED_CHANGE);
+    }
+
+    @Override
+	public void positionRider()
+    {
+        if (passenger != null) {
+            double d = Math.cos(((double) yRot * Math.PI) / 180D) * 0.4D;
+            double d1 = Math.sin(((double) yRot * Math.PI) / 180D) * 0.4D;
+            passenger.setPos(x + d, y + getRideHeight() + passenger.getRidingHeight(), z + d1);
+        }
+    }
+
+    @Override
+    public void waterHurt() {
+        return;
+    }
+
+    @Override
+	public float getShadowHeightOffs()
+    {
+        return 0.0F;
+    }
+
+    @Override
+	public boolean interact(Player entityplayer)
+    {
+        if(passenger != null && (passenger instanceof Player) && passenger != entityplayer)
+        {
+            return true;
+        }
+        if (passenger == entityplayer) {
+            ejectRider();
+            return true;
+        }
+        if(!world.isClientSide)
+        {
+            entityplayer.startRiding(this);
+        }
+        return true;
+    }
+    @Override
+    public Entity ejectRider() {
+        Entity entity = passenger;
+        if(entity == null) return null;
+
+        this.passenger = null;
+        entity.vehicle = null;
+
+        double bbCenterX = (bb.minX + bb.maxX)/2;
+        double bbCenterY = (bb.minY + bb.maxY)/2;
+        double bbCenterZ = (bb.minZ + bb.maxZ)/2;
+
+        boolean flag = false;
+        for (int i = 0; i < 4; i++) {
+            final double length = 1.75D;
+            double angle = Math.toRadians(yRot - 90) + (Math.PI/2) * i;
+            double checkX = bbCenterX + Math.cos(angle) * length;
+            double checkZ = bbCenterZ + Math.sin(angle) * length;
+            entity.moveTo(checkX, this.bb.maxY + 0.1, checkZ, entity.yRot, entity.xRot);
+            if (/*world.checkIfAABBIsClear(entity.bb) && */world.getCubes(entity, entity.bb).isEmpty()){
+                flag = true;
+                break;
+            }
+        }
+        if (!flag){
+            entity.moveTo(bbCenterX, this.bb.maxY + 0.1, bbCenterZ, entity.yRot, entity.xRot);
+        }
+        return entity;
+    }
+
+    @Override
+    protected void causeFallDamage(float distance){}
+}
diff --git a/game/core/src/main/java/net/minecraft/core/enums/HumanArmorShape.java b/game/core/src/main/java/net/minecraft/core/enums/HumanArmorShape.java
new file mode 100644
index 000000000..85653210e
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/enums/HumanArmorShape.java
@@ -0,0 +1,31 @@
+package net.minecraft.core.enums;
+
+public enum HumanArmorShape implements IArmorShape {
+    BOOTS(0.94f, 3),
+    LEGS(0.97f, 6),
+    CHEST(1.0f, 8),
+    HEAD(0.91f, 3);
+
+    private final float durabilityModifier;
+    private final int protectionValue;
+
+    HumanArmorShape(final float durabilityModifier, final int protectionValue) {
+        this.durabilityModifier = durabilityModifier;
+        this.protectionValue = protectionValue;
+    }
+
+    @Override
+    public int getSlotIndex() {
+        return this.ordinal();
+    }
+
+    @Override
+    public float getDurabilityModifier() {
+        return this.durabilityModifier;
+    }
+
+    @Override
+    public int getProtectionValue() {
+        return this.protectionValue;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/enums/IArmorShape.java b/game/core/src/main/java/net/minecraft/core/enums/IArmorShape.java
new file mode 100644
index 000000000..656d6c0a8
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/enums/IArmorShape.java
@@ -0,0 +1,9 @@
+package net.minecraft.core.enums;
+
+public interface IArmorShape {
+    int getSlotIndex();
+
+    float getDurabilityModifier();
+
+    int getProtectionValue();
+}
diff --git a/game/core/src/main/java/net/minecraft/core/enums/WolfArmorShape.java b/game/core/src/main/java/net/minecraft/core/enums/WolfArmorShape.java
new file mode 100644
index 000000000..b0ad85d44
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/enums/WolfArmorShape.java
@@ -0,0 +1,20 @@
+package net.minecraft.core.enums;
+
+public enum WolfArmorShape implements IArmorShape {
+    BODY;
+
+    @Override
+    public int getSlotIndex() {
+        return 0;
+    }
+
+    @Override
+    public float getDurabilityModifier() {
+        return 1.0f;
+    }
+
+    @Override
+    public int getProtectionValue() {
+        return 8;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/item/IArmorItem.java b/game/core/src/main/java/net/minecraft/core/item/IArmorItem.java
index f5e5cf4fd..c7f8a0148 100644
--- a/game/core/src/main/java/net/minecraft/core/item/IArmorItem.java
+++ b/game/core/src/main/java/net/minecraft/core/item/IArmorItem.java
@@ -1,26 +1,22 @@
 package net.minecraft.core.item;
 
+import net.minecraft.core.enums.IArmorShape;
 import net.minecraft.core.item.material.ArmorMaterial;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public interface IArmorItem {
-    int PIECE_HEAD = 3;
-    int PIECE_CHEST = 2;
-    int PIECE_LEGS = 1;
-    int PIECE_BOOTS = 0;
-    int[] ARMOR_PIECE_PROTECTION_VALUES = new int[] {3, 6, 8, 3};
+public interface IArmorItem<T extends IArmorShape> extends IItemConvertible {
+    @NotNull Item asItem();
+
+    @Nullable ArmorMaterial getArmorMaterial();
+
+    @NotNull T getArmorShape();
 
-    float[] ARMOR_PIECE_DURABILITY_MODIFIERS = new float[] {0.94f, 0.97f, 1.0f, 0.91f};
-    Item asItem(); // Ensure this has the same signature as Item's Item.asItem
-    @Nullable
-    ArmorMaterial getArmorMaterial();
-    int getArmorPiece();
     default int armorPieceProtection() {
-        return ARMOR_PIECE_PROTECTION_VALUES[getArmorPiece()];
+        return getArmorShape().getProtectionValue();
     }
 
     default float getArmorPieceProtectionPercentage() {
         return armorPieceProtection() / 20.0f;
     }
-
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/Item.java b/game/core/src/main/java/net/minecraft/core/item/Item.java
index 4c8041178..94f88a14f 100644
--- a/game/core/src/main/java/net/minecraft/core/item/Item.java
+++ b/game/core/src/main/java/net/minecraft/core/item/Item.java
@@ -331,7 +331,7 @@ public class Item implements ITaggable<Item>, IItemConvertible
     }
 
     @Override
-    public Item asItem() {
+    public @NotNull Item asItem() {
         return this;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemArmor.java b/game/core/src/main/java/net/minecraft/core/item/ItemArmor.java
index d7305ec5a..fca353a28 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemArmor.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemArmor.java
@@ -1,27 +1,32 @@
 package net.minecraft.core.item;
 
+import net.minecraft.core.enums.IArmorShape;
 import net.minecraft.core.item.material.ArmorMaterial;
+import org.jetbrains.annotations.NotNull;
 
-public class ItemArmor extends Item implements IArmorItem {
+public class ItemArmor<T extends IArmorShape>
+	extends Item
+	implements IArmorItem<T> {
 	private final ArmorMaterial material;
-	private final int armorPiece;
-	public ItemArmor(String name, String namespaceId, int id, ArmorMaterial material, int armorPiece) {
+	private final T armorShape;
+
+	public ItemArmor(final @NotNull String name, final @NotNull String namespaceId, final int id, ArmorMaterial material, final @NotNull T armorShape) {
 		super(name, namespaceId, id);
 		this.material = material;
-		this.armorPiece = armorPiece;
-		
-		setMaxDamage((int)(ARMOR_PIECE_DURABILITY_MODIFIERS[armorPiece] * material.durability));
+		this.armorShape = armorShape;
+
+		setMaxDamage((int)(armorShape.getDurabilityModifier() * material.durability));
 		
-		maxStackSize = 1;
+		this.maxStackSize = 1;
 	}
+
 	@Override
 	public ArmorMaterial getArmorMaterial() {
-		return material;
+		return this.material;
 	}
 
 	@Override
-	public int getArmorPiece() {
-		return armorPiece;
+	public @NotNull T getArmorShape() {
+		return this.armorShape;
 	}
-
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBow.java b/game/core/src/main/java/net/minecraft/core/item/ItemBow.java
index b17f40bf4..753c3c630 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBow.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBow.java
@@ -5,6 +5,7 @@ import net.minecraft.core.entity.projectile.ProjectileArrow;
 import net.minecraft.core.entity.projectile.ProjectileArrowGolden;
 import net.minecraft.core.entity.projectile.ProjectileArrowPurple;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.world.World;
 
 public class ItemBow extends Item
@@ -20,9 +21,9 @@ public class ItemBow extends Item
     @Override
     public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
     {
-        ItemStack quiverSlot = entityplayer.inventory.armorItemInSlot(IArmorItem.PIECE_CHEST);
+        ItemStack quiverSlot = entityplayer.getItemInArmorSlot(HumanArmorShape.CHEST);
         if(quiverSlot != null && quiverSlot.itemID == Items.ARMOR_QUIVER.id && quiverSlot.getMetadata() < quiverSlot.getMaxDamage()){
-            entityplayer.inventory.armorItemInSlot(IArmorItem.PIECE_CHEST).damageItem(1, entityplayer);
+            quiverSlot.damageItem(1, entityplayer);
             itemstack.damageItem(1, entityplayer);
             world.playSoundAtEntity(entityplayer, entityplayer, "random.bow", 0.3f, 1.0F / (itemRand.nextFloat() * 0.4F + 0.8F));
             if (!world.isClientSide) {
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java b/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
index 7bc7d50d4..2b6e2d6ed 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
@@ -61,23 +61,16 @@ public class ItemBucket extends Item
 		}
 		
 		if(world.isAirBlock(x, y, z) || !world.getBlockMaterial(x, y, z).isSolid()) {
-			if(world.dimension == Dimension.NETHER && blockToPlace == Blocks.FLUID_WATER_FLOWING) {
-				world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, z + 0.5, y + 0.5, x + 0.5, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
-				for (int l = 0; l < 8; l++) {
-					world.spawnParticle("largesmoke", x + Math.random(), y + Math.random(), z + Math.random(), 0.0D, 0.0D, 0.0D, 0);
-				}
-			} else {
-				if(blockToPlace == Blocks.FLUID_WATER_FLOWING) {
-					world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, x + 0.5F, y + 0.5F, z + 0.5F, "liquid.splash", 0.5f, 1.0f);
-				}
-				player.swingItem();
-				Block<?> block1 = world.getBlock(x, y, z);
-				if(block1 != null) {
-					block1.dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
-				}
-				world.setBlockAndMetadataWithNotify(x, y, z, blockToPlace.id(), 0);
-			}
-			if(player.getGamemode().consumeBlocks()) {
+            if (blockToPlace == Blocks.FLUID_WATER_FLOWING) {
+                world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, x + 0.5F, y + 0.5F, z + 0.5F, "liquid.splash", 0.5f, 1.0f);
+            }
+            player.swingItem();
+            Block<?> block1 = world.getBlock(x, y, z);
+            if(block1 != null) {
+                block1.dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
+            }
+            world.setBlockAndMetadataWithNotify(x, y, z, blockToPlace.id(), 0);
+            if(player.getGamemode().consumeBlocks()) {
 				return new ItemStack(Items.BUCKET);
 			}
 		}
